#include <math.h>
#include <stdlib.h>
#include<iostream.h>
#include "vecdefs.h"
#include "mvm.h"



void lufact(const MATRIX_double &A,int k,MATRIX_double &L,MATRIX_double &U)
{
  int i;
  int j;
 
  MATRIX_double elim(int,int,int,double);
 MATRIX_double operator*(const MATRIX_double &,const MATRIX_double &);
  {
    U = A;
    L = elim(k,1,2,0.0);
    MATRIX_double el(A.dim(0),A.dim(1));
    for(i = 1;i < k;i++)
      if( U(i-1,i-1) == 0.0 )
        exit(-1);
      else 
        for(j = i+1;j <= k;j++)
        {
          el = elim(k,j,i,-U(j-1,i-1)/U(i-1,i-1));
          L(j-1,i-1) = U(j-1,i-1)/U(i-1,i-1);
          U = el*U;
        }
    if( U(k-1,k-1) == 0.0 )
      exit(-1);
 
  }
 
}

