 
#include<stdlib.h>
#include<stdio.h>
#include<math.h>
#include<iostream.h>
#include "vecdefs.h"
#include "mvvd.h"


double dotprod(const VECTOR_double & u,const VECTOR_double & v)
{ 
  double s;
  {
    if( u.size() != v.size() )
      {
        fprintf(stderr, "dimensions don't match" );
        exit(1);
      }
  int  n = u.size();
    s = 0.0;
    for(int i = 1;i <= n;i++)
      s += u[i-1]*v[i-1];
    return(s);
  }
}

double norm(const VECTOR_double &v)
{
  {
    return(sqrt(0.1E1*dotprod(v,v)));
  }
}


double angle(const VECTOR_double u,const VECTOR_double v)
{
  {
    return(acos(dotprod(u,v)/norm(u)/norm(v)));
  }
}

