#include <math.h>
#include <stdlib.h>
#include<iostream.h>
#include "vecdefs.h"
#include "mvm.h"

MATRIX_double stackmatrix(const MATRIX_double &A,const MATRIX_double &B)
{
  
  int ra = A.dim(0);
  int ca= A.dim(1);
  int rb= B.dim(0);
  MATRIX_double C(ra+rb,ca);
  int i;
  int j;
  {
    
    for(i = 1;i <= rb;i++)
      for(j = 1;j <= ca;j++)
        C(i-1, j-1) = B(i-1,j-1);
    for(i = rb+1;i <= ra+rb;i++)
      for(j = 1;j <= ca;j++)
        C(i-1, j-1) = A(i-rb-1,j-1);
    return(C);
  }
}

